#ifndef SS_TINY85_H
#define SS_TINY85_H

#include <avr/io.h>
#include <inttypes.h>
#include <stddef.h>

//#define TX_ONLY

//
// Hardcoded TX/RX Registers
//
//   For ATtiny85 you MUST use I/O port B.
//
#define SERDDR	DDRB
#define SERPORT	PORTB
#define SERPIN	PINB
#define RXPIN	PB0       // Pin6
#define TXPIN	PB1       // Pin5

//
// Definitions
//
#define _SS_MAX_RX_BUFF 64 // RX buffer size, must be (1<<n)
#define _SS_RX_BUFF_MASK (_SS_MAX_RX_BUFF-1)
#ifndef GCC_VERSION
#define GCC_VERSION (__GNUC__ * 10000 + __GNUC_MINOR__ * 100 + __GNUC_PATCHLEVEL__)
#endif

//
// public methods
//
void ssBegin(long speed);
void ssEnd();
bool ssOverflow();
int ssPeek();
size_t ssWrite(uint8_t byte);
int ssRead();
int ssAvailable();
void ssFlush();
int ssPeek();

// New print functions
void ssPrint(const char* str);
void ssPrint(const __FlashStringHelper *ifsh);
void ssPrint(int num);
void ssPrintHex(int num);
void ssPrintln(const char* str);
void ssPrintln(const __FlashStringHelper *ifsh);
void ssPrintln(int num);
void ssPrintlnHex(int num);
void ssPrintln();

#endif
