#include "SS_Tiny85.h"

#define SENSOR    PB2     // pin7   
#define LED      PB4     // pin3 

volatile bool triggered = false;
uint32_t oldTriggerTime = 0;       
uint32_t newTriggerTime = 0;       

ISR(INT0_vect) {
  
  triggered = true;
  
}

void setup() {
  CLKPR |= (1 << CLKPCE);                                                       // Aktivieren der Taktprescaler-Änderung
  CLKPR = (0 << CLKPS3) | (0 << CLKPS2) | (0 << CLKPS1) | (0 << CLKPS0);        // Setzen auf 8 MHz ohne Prescaler
  OSCCAL = 0x89;
  
  pinMode (SENSOR, INPUT);
  pinMode (LED, OUTPUT);

  MCUCR |= (1 << ISC01);                  // The falling edge of INT0 generates an interrupt request.
  GIMSK |= (1 << INT0);                   // External Interrupt Request 0 Enable

  sei();

  ssBegin(9600);
}

void loop() {
  if ( triggered ) {
    
    newTriggerTime = micros();
    triggered = false;
    
    uint32_t us;
    if ( newTriggerTime > oldTriggerTime ) {
      us = newTriggerTime - oldTriggerTime;
    } 
    ssPrint(F("difference : "));
    ssPrintln(us);
    
    oldTriggerTime = newTriggerTime;

  } 

}
